#include "postgres.h"
#include "molecule_limits.h"

#ifndef SET_VARSIZE // < 8.3 compatibility
#define SET_VARSIZE(v,l) (VARATT_SIZEP(v) = (l))
#endif

typedef struct
{
  uint32 fp[FPSIZE];
} MOLFP;

typedef struct
{
  int4 len;
  int4 sizemf;
  int4 sizesmi;
  int4 disconnected;
  uint32 fp[FPSIZE];
  char molhash[MOLHASHSZ];
  char data[1];
} MOLECULE;

#define MOLHDRSZ		             (4*sizeof(int4))
#define SMIPTR(x)		 	         ((char*)(x->data))
#define MFPTR(x)		 		     ((char*)(x->data+x->sizesmi))
#define CALCDATASZ(sizemf, sizesmi)  (((FPSIZE)*sizeof(uint32)) + MOLHDRSZ + MOLHASHSZ + sizemf + sizesmi)

#define PG_GETARG_MOLFP_P(n)         (MOLFP *) DatumGetPointer(PG_GETARG_DATUM(n))
#define PG_RETURN_MOLFP_P(n)         PG_RETURN_POINTER(n)

#define DatumGetMoleculeP(n)         ((MOLECULE *) PG_DETOAST_DATUM(n))
#define PG_GETARG_MOLECULE_P(n)      DatumGetMoleculeP(PG_GETARG_DATUM(n))
#define PG_RETURN_MOLECULE_P(n)      PG_RETURN_POINTER(n)

